#!/bin/bash

# BUILD PERL
# USE THE CORRECT PERL BINARY AND TMP DIRS
whichos=`uname`
PATCHER=patch
if [ "$whichos" = "SunOS" ]; then
        PATH=/usr/local/bin:/usr/ccs/bin:$PATH
	PATCHER=gpatch
fi
PATH=$PWD/PerlSrc/perl/bin:$PATH
PERLBIN=$PWD/PerlSrc/perl/bin/perl
export PATH
TEMPDIR=$PWD/tmp
TMP=$PWD/tmp
export TMP
export TEMPDIR

# BUILD VCP
if [ -f Tars/VCP-[0-9]*.tar.gz ] ; then
	cd PerlModules
	gzip -dc ../Tars/VCP-[0-9]*.tar.gz | tar xvf -
	#tar zxvf ../Tars/VCP-[0-9]*.tar.gz
	cd ..
	if [ -d dist ] ; then
		echo "Building into $PWD/dist"
	else
		mkdir dist
		echo "Building into $PWD/dist"
	fi
elif [ -d PerlModules/VCP-[0-9]* ] ; then
	if [ -d dist ] ; then
		echo "Building into $PWD/dist"
	else
		mkdir dist
		echo "Building into $PWD/dist"
	fi
else
	echo "PerlModule/VCP-... is not installed"
	echo "  Either put VCP-...tar.gz into Tars"
	echo "  or untar VCP-...tar.gz into PerlModules"
	exit
fi
cd PerlModules
version=`ls -d VCP-[0-9]* | sed -e 's/VCP/vcp/' | sed -e 's=/==g'`
cd VCP-[0-9]*
if [ -f Makefile ] ; then
	make clean
	/bin/rm Makefile.old
fi
perl Makefile.PL
make
for f in bin/* t/*; do 
	sed -e "s=#!/usr/local/bin/perl=#!$PERLBIN=" $f > $f.$$
	/bin/mv -f $f.$$ $f
done

# Save dist version of vcp and remove module list code which breaks tests
make test
make install

# BUILD HTML TREE
make vcp_html/index.html

# BUILD EXE VCP
# Restore dist version
# drop the -lib=lib so that it uses the installed version
# $PATCHER -i ../../vcp.bin.build_vcp_executable.pl.patch bin/build_vcp_executable.pl 
$PERLBIN bin/build_vcp_executable.pl

# TEST EXE
#   ***TBD***

kername=`uname -r`
if [ -f ../../dist/$version-$kername.exe ] ; then
	/bin/rm -f ../../dist/$version-$kername.exe
fi
/bin/cp vcp-bin ../../dist/$version-$kername.exe
gzip ../../dist/$version-$kername.exe
if [ -d ../../dist/html ] ; then
	/bin/rm -rf ../../dist/html
fi
if [ -d ../../dist/vcp_html ] ; then
	/bin/rm -rf ../../dist/vcp_html
fi
tar cf - vcp_html | (cd ../../dist ; tar xf - )
/bin/mv ../../dist/vcp_html ../../dist/html

echo "VCP Binary: $version-$kername.exe.gz"

