#!/bin/bash

# Retrieve current stable perl
if [ -d Tars ]; then
	cd Tars
else
	mkdir Tars
	cd Tars
fi

# CURRENT PERL SOURCE
echo "http://www.cpan.org/src/stable.tar.gz" > modules.$$

# Required for Math::Pari
echo "ftp://megrez.math.u-bordeaux.fr/pub/pari/unix/pari-2.1.7.tgz" >> modules.$$

# Retrieve list of current modules
wget -N http://www.cpan.org/modules/02packages.details.txt.gz
if [ -f perl-modules.txt.gz ] ; then
	/bin/rm perl-modules.txt.gz
fi
if [ -f perl-modules.txt ] ; then
	/bin/rm perl-modules.txt
fi
cp 02packages.details.txt.gz perl-modules.txt.gz
gunzip perl-modules.txt.gz

# PAR REQUIRED MODULES
for f in `cat ../par-deps.list`; do
	echo "Looking for $f..."
	# LWP::UserAgent in libwww-perl package
	if [ "$f" = "libwww-perl" ] ; then
		f="LWP::UserAgent"
		echo "revising to $f..."
	fi
	# Crypt::DSA version 13 is broken use 12 instead
	if [ "$f" = "Crypt::DSA" ] ; then
			echo "revising version for $f to 12 ..."
			egrep -e "^$f " perl-modules.txt | head -1 | awk '{ printf "http://search.cpan.org/CPAN/authors/id/%s\n", $3; }' | sed -e 's/13/12/' >> modules.$$
	else
			
		egrep -e "^$f " perl-modules.txt | head -1 | awk '{ printf "http://search.cpan.org/CPAN/authors/id/%s\n", $3; }' >> modules.$$
	fi
done


# ADD PAR
# PAR 0.83 is broken, use 0.82
# Trying PAR 0.85
echo "Looking for PAR-..."
egrep -e "^PAR " perl-modules.txt | head -1 | awk '{ printf "http://search.cpan.org/CPAN/authors/id/%s\n", $3; }' | sed -e 's/85/85/' >> modules.$$

# VCP REQUIRED MODULES
for f in `cat ../vcp-deps.list`; do
	echo "Looking for $f..."
	# Pod:HTML_Elements and PoD:Links are in PodToHTML package
	if [ "$f" = "PodToHTML" ] ; then
		f="Pod::HTML_Elements"
	# HTML::FormatPS is in HTML::Format package
	elif [ "$f" = "HTML::Format" ] ; then
		f="HTML::FormatPS"
	# IO::File is in IO package
	elif [ "$f" = "IO" ] ; then
		f="IO::File"
	fi
	egrep -e "^$f " perl-modules.txt | head -1 | awk '{ printf "http://search.cpan.org/CPAN/authors/id/%s\n", $3; }' >> modules.$$
done

if [ -f perl-modules.txt.gz ] ; then
	/bin/rm perl-modules.txt.gz
fi
if [ -f perl-modules.txt ] ; then
	/bin/rm perl-modules.txt
fi
sort modules.$$ > modules.list
/bin/rm modules.$$
echo "modules.list generated, run '(cd Tars; wget -N -i modules.list)' to retrieve modules"
